import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;


public class Game extends JFrame {
	
	
	private Container cp;
	private KnightFightEngine engine;
	private JLabel brPoteza, igracNaPotezu;
	private JPanel tabla;
	private MyButton[][] bs;
	
	
	Game(){
		super("KnightFightGame");
		setBounds(100,100,400,400);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setVisible(true);
		
		cp = getContentPane();
		engine = new KnightFightEngine();
		cp.setLayout(new BorderLayout());
		
		
		postaviGore();
		postaviTablu();
		postaviDole();
		inicijalizujSve();
		
		
		
	}
	
	
	private void postaviGore(){
		brPoteza = new JLabel("Poteza: "+engine.getMoveCount());
		igracNaPotezu = new JLabel("Na potezu je: "+engine.getActivePlayer()+" igrac");
		igracNaPotezu.setAlignmentX(Component.LEFT_ALIGNMENT);
		
		JPanel panel = new JPanel();
		panel.setLayout(new GridLayout(1,2));
		panel.add(brPoteza);
		panel.add(igracNaPotezu);
		
		
		cp.add(panel,BorderLayout.NORTH);
		
	}
	
	private void postaviTablu(){
		
		tabla = new JPanel();
		tabla.setLayout(new GridLayout(8,8));
		tabla.removeAll();
		bs = new MyButton[8][8];
		for(int i = 0; i < 8; i++)
			for(int j = 0; j < 8; j++){
				bs[i][j] = new MyButton(i, j);
				bs[i][j].addActionListener(new ActionListener() {
					
					@Override
					public void actionPerformed(ActionEvent arg0) {
						// TODO Auto-generated method stub
						MyButton b = ((MyButton)arg0.getSource());
						if(engine.klik(b.i,b.j)){
							resetujTablu();
							nacrtajFigure(engine.getFigures());
						};
					}
				});
				tabla.add(bs[i][j]);
			}
		tabla.revalidate();
		cp.add(tabla, BorderLayout.CENTER);
	}
	
	private void postaviDole(){
		JButton b = new JButton("Nova");
		b.setPreferredSize(new Dimension(20,30));
		b.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				// TODO Auto-generated method stub
				engine.initialize();
				inicijalizujSve();
			}
		});
		cp.add(b,BorderLayout.SOUTH);
	}
	
	
	private void nacrtajFigure(Figure[] figs){
		
		
		for(int x = 0; x < figs.length; x++){
			bs[figs[x].i][figs[x].j].postaviFiguru(figs[x]);
		}
		
	}
	
	private void resetujTablu(){
		tabla.removeAll();
		postaviTablu();
		tabla.revalidate();
		repaint();
	}
	
	
	private void inicijalizujSve(){
		resetujTablu();
		
		brPoteza.setText("Potez: "+engine.getMoveCount());
		igracNaPotezu.setText("Na potezu je "+engine.getActivePlayer()+" igrac");
		
		nacrtajFigure(engine.getFigures());
		
			
		}
		
	}
